=== modified file 'm4/pandora_64bit.m4'
--- m4/pandora_64bit.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_64bit.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 dnl ---------------------------------------------------------------------------
 dnl Macro: PANDORA_64BIT
 dnl ---------------------------------------------------------------------------
@@ -24,12 +29,13 @@
          fi
          CPPFLAGS="-m64 ${CPPFLAGS}"
          LDFLAGS="-m64 ${LDFLAGS}"
+         DTRACEFLAGS="${DTRACEFLAGS} -64"
          if test "$target_cpu" = "sparc" -a "x$SUNCC" = "xyes"
          then
             AM_CFLAGS="-xmemalign=8s ${AM_CFLAGS}"
             AM_CXXFLAGS="-xmemalign=8s ${AM_CXXFLAGS}"
          fi
-       ])
+       ],[DTRACEFLAGS="${DTRACEFLAGS} -32"])
 ])
 dnl ---------------------------------------------------------------------------
 dnl End Macro: PANDORA_64BIT

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_canonical.m4	2009-07-08 07:09:13 +0000
@@ -1,23 +1,40 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+dnl Which version of the canonical setup we're using
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.1])
+
+AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
+  dnl Force dependency tracking on for Sun Studio builds
+  AS_IF([test "x${enable_dependency_tracking}" = "x"],[
+    enable_dependency_tracking=yes
+  ])
+])
+
 dnl The standard setup for how we build Pandora projects
-
 AC_DEFUN([PANDORA_CANONICAL_TARGET],[
-  PCT_USE_GNULIB=no
-  PCT_REQUIRE_CXX=no
-  PCT_IGNORE_SHARED_PTR=no
-  PCT_ALL_ARGS="$@"
-  for arg in $@ ; do
-    case "$arg" in
-      use-gnulib)
-        PCT_USE_GNULIB=yes
-        ;;
-      require-cxx)
-        PCT_REQUIRE_CXX=yes
-        ;;
-      ignore-shared-ptr)
-        PCT_IGNORE_SHARED_PTR=yes
-        ;;
-    esac
-  done
+  AC_REQUIRE([PANDORA_FORCE_DEPEND_TRACKING])
+  m4_define([PCT_ALL_ARGS],[$@])
+  m4_define([PCT_USE_GNULIB],[no])
+  m4_define([PCT_REQUIRE_CXX],[no])
+  m4_define([PCT_IGNORE_SHARED_PTR],[no])
+  m4_foreach_w([pct_arg],$@,[
+    m4_case(pct_arg,
+      [use-gnulib], [
+        m4_undefine([PCT_USE_GNULIB])
+        m4_define([PCT_USE_GNULIB],[yes])
+      ],
+      [require-cxx], [
+        m4_undefine([PCT_REQUIRE_CXX])
+        m4_define([PCT_REQUIRE_CXX],[yes])
+      ],
+      [ignore-shared-ptr], [
+        m4_undefine([PCT_IGNORE_SHARED_PTR])
+        m4_define([PCT_IGNORE_SHARED_PTR],[yes])
+    ])
+  ])
 
   # We need to prevent canonical target
   # from injecting -O2 into CFLAGS - but we won't modify anything if we have
@@ -30,19 +47,11 @@
   AC_CANONICAL_TARGET
   
   AM_INIT_AUTOMAKE(-Wall -Werror nostdinc subdir-objects)
-  AS_IF([test "x${PCT_USE_GNULIB}" = "xyes"], [
-    echo ${ECHO_N} ""
-    gl_EARLY
-  ])
+
+  m4_if(PCT_USE_GNULIB,yes,[ gl_EARLY ])
   
   AC_REQUIRE([AC_PROG_CC])
 
-  dnl Force dependency tracking on for Sun Studio builds
-  AS_IF([test "x${enable_dependency_tracking}" = "x"],[
-    enable_dependency_tracking=yes
-  ])
-
-  
   dnl Once we can use a modern autoconf, we can use this
   dnl AC_PROG_CC_C99
   AC_PROG_CXX
@@ -54,25 +63,24 @@
 
   PANDORA_LIBTOOL
 
+  dnl autoconf doesn't automatically provide a fail-if-no-C++ macro
+  dnl so we check c++98 features and fail if we don't have them, mainly
+  dnl for that reason
   PANDORA_CHECK_CXX_STANDARD
-  AS_IF([test "$PCT_REQUIRE_CXX" = "yes"],[
+  m4_if(PCT_REQUIRE_CXX, [yes], [
     AS_IF([test "$ac_cv_cxx_stdcxx_98" = "no"],[
       AC_MSG_ERROR([No working C++ Compiler has been found. ${PACKAGE} requires a C++ compiler that can handle C++98])
     ])
   ])
   
   PANDORA_SHARED_PTR
-  AS_IF([test "$PCT_IGNORE_SHARED_PTR" = no],[
+  m4_if(PCT_IGNORE_SHARED_PTR, [no], [
     AS_IF([test "$ac_cv_shared_ptr_namespace" = "missing"],[
       AC_MSG_WARN([a usable shared_ptr implementation was not found. Let someone know what your platform is.])
     ])
   ])
   
-  AS_IF([test "x${PCT_USE_GNULIB}" = "xyes"], [
-    dnl TODO: replace this run-time test with an m4 compile-time test
-    echo ${ECHO_N} ""
-    gl_INIT
-  ])
+  m4_if(PCT_USE_GNULIB, [yes], [gl_INIT])
 
   AC_C_BIGENDIAN
   AC_C_CONST
@@ -86,16 +94,17 @@
   
 
   AC_CHECK_DECL([__SUNPRO_C], [SUNCC="yes"], [SUNCC="no"])
+
+  AC_SYS_LARGEFILE
+
+  AS_IF([test "$GCC" = "yes"], PANDORA_ENSURE_GCC_VERSION)
+
   PANDORA_CHECK_C_VERSION
   PANDORA_CHECK_CXX_VERSION
 
-  AC_SYS_LARGEFILE
-
-  PANDORA_MAC_GCC42
-
   PANDORA_OPTIMIZE
   PANDORA_64BIT
-  PANDORA_WARNINGS($PCT_ALL_ARGS)
+  PANDORA_WARNINGS(PCT_ALL_ARGS)
 
   gl_VISIBILITY
 

=== modified file 'm4/pandora_check_compiler_version.m4'
--- m4/pandora_check_compiler_version.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_check_compiler_version.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,9 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+
 AC_DEFUN([PANDORA_CHECK_C_VERSION],[
 
   dnl Print version of C compiler

=== modified file 'm4/pandora_check_cxx_standard.m4'
--- m4/pandora_check_cxx_standard.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_check_cxx_standard.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 AC_DEFUN([PANDORA_CHECK_CXX_STANDARD],[
   AC_REQUIRE([AC_CXX_COMPILE_STDCXX_0X])
   AS_IF([test "$GCC" = "yes"],

=== modified file 'm4/pandora_enable_dtrace.m4'
--- m4/pandora_enable_dtrace.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_enable_dtrace.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 dnl ---------------------------------------------------------------------------
 dnl Macro: PANDORA_ENABLE_DTRACE
 dnl ---------------------------------------------------------------------------
@@ -12,11 +17,24 @@
     AC_CHECK_PROGS([DTRACE], [dtrace])
     AS_IF([test "x$ac_cv_prog_DTRACE" = "xdtrace"],[
       AC_DEFINE([HAVE_DTRACE], [1], [Enables DTRACE Support])
+      dnl DTrace on MacOSX does not use -G option
+      cat >conftest.d <<_ACEOF
+provider Example {
+  probe increment(int);
+};
+_ACEOF
+      $DTRACE -G -o conftest.d.o -s conftest.d 2>/dev/zero
+      AS_IF([test $? -eq 0],[ac_cv_dtrace_needs_objects=yes])
+      rm -f conftest.d.o conftest.d
+
       AC_SUBST(DTRACEFLAGS) dnl TODO: test for -G on OSX
       ac_cv_have_dtrace=yes
     ])])
 
-AM_CONDITIONAL([HAVE_DTRACE], [ test "x$ac_cv_have_dtrace" = "xyes" ])
+AM_CONDITIONAL([HAVE_DTRACE], [test "x$ac_cv_have_dtrace" = "xyes"])
+AM_CONDITIONAL([DTRACE_NEEDS_OBJECTS],
+               [test "x$ac_cv_dtrace_needs_objects" = "xyes"])
+
 ])
 dnl ---------------------------------------------------------------------------
 dnl End Macro: PANDORA_ENABLE_DTRACE

=== modified file 'm4/pandora_ensure_gcc_version.m4'
--- m4/pandora_ensure_gcc_version.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_ensure_gcc_version.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 dnl If the user is on a Mac and didn't ask for a specific compiler
 dnl You're gonna get 4.2.
 AC_DEFUN([PANDORA_MAC_GCC42],
@@ -26,6 +31,6 @@
       [ac_cv_gcc_recent=no])])
   AS_IF([test "$ac_cv_gcc_recent" = "no" -a "$host_vendor" = "apple"],
     AC_MSG_ERROR([Your version of GCC is too old. At least version 4.2 is required on OSX. You may need to install a version of XCode >= 3.1.2]))
-  AS_IF([test "$drizzle_cv_gcc_recent" = "no"],
+  AS_IF([test "$ac_cv_gcc_recent" = "no"],
     AC_MSG_ERROR([Your version of GCC is too old. At least version 4.1 is required]))
 ])

=== modified file 'm4/pandora_header_assert.m4'
--- m4/pandora_header_assert.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_header_assert.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 dnl PANDORA_HEADER_ASSERT
 dnl ----------------
 dnl Check whether to enable assertions.

=== modified file 'm4/pandora_libtool.m4'
--- m4/pandora_libtool.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_libtool.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 AC_DEFUN([PANDORA_LIBTOOL],[
   AC_REQUIRE([AC_PROG_LIBTOOL])
   dnl By requiring AC_PROG_LIBTOOL, we should force the macro system to read

=== modified file 'm4/pandora_optimize.m4'
--- m4/pandora_optimize.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_optimize.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 AC_DEFUN([PANDORA_OPTIMIZE],[
   dnl Build optimized or debug version ?
   dnl First check for gcc and g++
@@ -31,14 +36,14 @@
     dnl Once we can use a modern autoconf, we can replace the -xc99=all here
     dnl with using AC_CC_STD_C99 above
     CC="${CC} -xc99=all"
-    CXX="${CXX} -xlang=c99 "
+    CXX="${CXX} -xlang=c99"
 
-    AM_CFLAGS="-g -mt ${AM_CFLAGS}"
+    AM_CFLAGS="-g -mt -xstrconst -Xa ${AM_CFLAGS}"
     AM_CXXFLAGS="-g -mt -compat=5 -library=stlport4 -template=no%extdef ${AM_CXXFLAGS}"
 
     dnl TODO: Make a test for -xO4 usability here
     OPTIMIZE_FLAGS="-xO3 -xlibmil -xdepend -xbuiltin"
-    OPTIMIZE_CFLAGS="${OPTIMIZE_FLAGS} -Xa -xstrconst"
+    OPTIMIZE_CFLAGS="${OPTIMIZE_FLAGS}"
     OPTIMIZE_CXXFLAGS="${OPTIMIZE_FLAGS}"
   ])
 

=== modified file 'm4/pandora_shared_ptr.m4'
--- m4/pandora_shared_ptr.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_shared_ptr.m4	2009-07-08 07:09:13 +0000
@@ -1,16 +1,21 @@
-# We check two things: where is the memory include file, and in what
-# namespace does shared_ptr reside.
-# We include AC_COMPILE_IFELSE for all the combinations we've seen in the
-# wild:
-# 
-#  GCC 4.3: namespace: std::  #include <memory>
-#  GCC 4.2: namespace: tr1::  #include <tr1/memory>
-#  GCC 4.2: namespace: boost::  #include <boost/shared_ptr.hpp>
-#
-# We define one of HAVE_HAVE_TR1_SHARED_PTR or HAVE_BOOST_SHARED_PTR
-# depending on location, and SHARED_PTR_NAMESPACE to be the namespace in
-# which shared_ptr is defined.
-#
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+dnl We check two things: where is the memory include file, and in what
+dnl namespace does shared_ptr reside.
+dnl We include AC_COMPILE_IFELSE for all the combinations we've seen in the
+dnl wild:
+dnl 
+dnl  GCC 4.3: namespace: std::  #include <memory>
+dnl  GCC 4.2: namespace: tr1::  #include <tr1/memory>
+dnl  GCC 4.2: namespace: boost::  #include <boost/shared_ptr.hpp>
+dnl
+dnl We define one of HAVE_HAVE_TR1_SHARED_PTR or HAVE_BOOST_SHARED_PTR
+dnl depending on location, and SHARED_PTR_NAMESPACE to be the namespace in
+dnl which shared_ptr is defined.
+dnl 
 
 AC_DEFUN([PANDORA_SHARED_PTR],[
   AC_REQUIRE([PANDORA_CHECK_CXX_STANDARD])

=== modified file 'm4/pandora_vc_build.m4'
--- m4/pandora_vc_build.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_vc_build.m4	2009-07-08 07:09:13 +0000
@@ -1,3 +1,8 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 AC_DEFUN([PANDORA_BUILDING_FROM_VC],[
 
   ac_cv_building_from_vc=no
@@ -24,4 +29,4 @@
   ])
 
 ])
-  
\ No newline at end of file
+  

=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2009-07-07 09:09:30 +0000
+++ m4/pandora_warnings.m4	2009-07-08 07:09:13 +0000
@@ -1,25 +1,33 @@
+dnl  Copyright (C) 2009 Sun Microsystems
+dnl This file is free software; Sun Microsystems
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
 dnl AC_PANDORA_WARNINGS([less-warnings|warnings-always-on])
 dnl   less-warnings turn on a limited set of warnings
 dnl   warnings-always-on always set warnings=error regardless of tarball/vc
  
 AC_DEFUN([PANDORA_WARNINGS],[
-  PW_FULL_WARNINGS=yes
-  PW_VC_WARN_OFF=yes
-  for arg in $@ ; do
-    case "$arg" in
-      less-warnings)
-        PW_FULL_WARNINGS=no
-        ;;
-      warnings-always-on)
-        PW_VC_WARN_OFF=no
-        ;;
-    esac
-  done
+  m4_define([PW_LESS_WARNINGS],[no])
+  m4_define([PW_WARN_ALWAYS_ON],[no])
+  m4_foreach_w([pw_arg],$@,[
+    m4_case(pw_arg,
+      [less-warnings],[
+        m4_undefine([PW_LESS_WARNINGS])
+        m4_define([PW_LESS_WARNINGS],[yes])
+      ],
+      [warnings-always-on],[
+        m4_undefine([PW_WARN_ALWAYS_ON])
+        m4_define([PW_WARN_ALWAYS_ON],[yes])
+    ]) 
+  ])
 
   AC_REQUIRE([PANDORA_BUILDING_FROM_VC])
-  AS_IF([test "${PW_VC_WARN_OFF}" = "no" -o "$ac_cv_building_from_vc" = "yes"],
+  m4_if(PW_WARN_ALWAYS_ON, [yes],
     [ac_cv_warnings_as_errors=yes],
-    [ac_cv_warnings_as_errors=no])
+    AS_IF([test "$ac_cv_building_from_vc" = "yes"],
+          [ac_cv_warnings_as_errors=yes],
+          [ac_cv_warnings_as_errors=no]))
 
   AC_ARG_ENABLE([profiling],
       [AS_HELP_STRING([--enable-profiling],
@@ -110,7 +118,7 @@
     NO_STRICT_ALIASING="-fno-strict-aliasing -Wno-strict-aliasing"
     NO_SHADOW="-Wno-shadow"
 
-    AS_IF([test "${PW_FULL_WARNINGS}" = "yes"],[
+    m4_if(PW_LESS_WARNINGS,[no],[
       BASE_WARNINGS_FULL="-Wformat=2 ${W_CONVERSION} -Wstrict-aliasing"
       CC_WARNINGS_FULL="-Wswitch-default -Wswitch-enum"
       CXX_WARNINGS_FULL="-Weffc++ -Wold-style-cast"
@@ -118,14 +126,33 @@
       BASE_WARNINGS_FULL="-Wformat ${NO_STRICT_ALIASING}"
     ])
 
-    BASE_WARNINGS="-pedantic -Wall -Wextra ${W_FAIL} -Wundef -Wshadow -Wmissing-declarations -Wstrict-aliasing ${F_DIAGNOSTICS_SHOW_OPTION} ${CFLAG_VISIBILITY} ${BASE_WARNINGS_FULL}"
-    CC_WARNINGS="${BASE_WARNINGS} -Wstrict-prototypes -Wmissing-prototypes -Wredundant-decls ${CC_WARNINGS_FULL} -Wcast-align"
+    BASE_WARNINGS="${W_FAIL} -pedantic -Wall -Wextra -Wundef -Wshadow -Wstrict-aliasing ${F_DIAGNOSTICS_SHOW_OPTION} ${CFLAG_VISIBILITY} ${BASE_WARNINGS_FULL}"
+    CC_WARNINGS="${BASE_WARNINGS} -Wstrict-prototypes -Wmissing-prototypes -Wredundant-decls -Wmissing-declarations -Wcast-align ${CC_WARNINGS_FULL}"
     CXX_WARNINGS="${BASE_WARNINGS} -Woverloaded-virtual -Wnon-virtual-dtor -Wctor-dtor-privacy -Wno-long-long ${CXX_WARNINGS_FULL}"
 
+    AC_CACHE_CHECK([whether it is safe to use -Wmissing-declarations from C++],
+      [ac_cv_safe_to_use_Wmissing_declarations_],
+      [AC_LANG_PUSH(C++)
+       save_CXXFLAGS="$CXXFLAGS"
+       CXXFLAGS="-Werror -pedantic -Wmissing-declarations ${AM_CXXFLAGS}"
+       AC_COMPILE_IFELSE([
+         AC_LANG_PROGRAM(
+         [[
+#include <stdio.h>
+         ]], [[]])
+      ],
+      [ac_cv_safe_to_use_Wmissing_declarations_=yes],
+      [ac_cv_safe_to_use_Wmissing_declarations_=no])
+      CXXFLAGS="$save_CXXFLAGS"
+      AC_LANG_POP()
+    ])
+    AS_IF([test "$ac_cv_safe_to_use_Wmissing_declarations_" = "yes"],
+          [CXX_WARNINGS="${CXX_WARNINGS} -Wmissing-declarations"])
+
     AC_CACHE_CHECK([whether it is safe to use -Wlogical-op],
       [ac_cv_safe_to_use_Wlogical_op_],
       [save_CFLAGS="$CFLAGS"
-       CFLAGS="-Wlogical-op -Werror -pedantic ${AM_CFLAGS}"
+       CFLAGS="${W_FAIL} -pedantic -Wlogical-op ${AM_CFLAGS}"
        AC_COMPILE_IFELSE([
          AC_LANG_PROGRAM(
          [[
@@ -142,7 +169,7 @@
       [ac_cv_safe_to_use_Wredundant_decls_],
       [AC_LANG_PUSH(C++)
        save_CXXFLAGS="${CXXFLAGS}"
-       CXXFLAGS="-Wredundant-decls ${W_FAIL} -pedantic -Wredundant-decls"
+       CXXFLAGS="${W_FAIL} -pedantic -Wredundant-decls ${AM_CXXFLAGS}"
        AC_COMPILE_IFELSE(
          [AC_LANG_PROGRAM([
 template <typename E> struct C { void foo(); };
@@ -188,7 +215,7 @@
       [W_PASTE_RESULT=",E_PASTE_RESULT_NOT_TOKEN"])
 
 
-    AS_IF([test "${PW_FULL_WARNINGS}" = "yes"],[
+    m4_if(PW_LESS_WARNINGS, [no],[
       CC_WARNINGS_FULL="-erroff=E_INTEGER_OVERFLOW_DETECTED${W_PASTE_RESULT}"
     ],[
       CC_WARNINGS_FULL="-erroff=E_ATTRIBUTE_NOT_VAR"
@@ -209,5 +236,4 @@
   AC_SUBST(NO_STRICT_ALIASING)
   AC_SUBST(PROTOSKIP_WARNINGS)
 
-
 ])

=== added file 'm4/visibility.m4'
--- m4/visibility.m4	1970-01-01 00:00:00 +0000
+++ m4/visibility.m4	2009-07-08 07:09:13 +0000
@@ -0,0 +1,52 @@
+# visibility.m4 serial 2 (gettext-0.18)
+dnl Copyright (C) 2005, 2008 Free Software Foundation, Inc.
+dnl This file is free software; the Free Software Foundation
+dnl gives unlimited permission to copy and/or distribute it,
+dnl with or without modifications, as long as this notice is preserved.
+
+dnl From Bruno Haible.
+
+dnl Tests whether the compiler supports the command-line option
+dnl -fvisibility=hidden and the function and variable attributes
+dnl __attribute__((__visibility__("hidden"))) and
+dnl __attribute__((__visibility__("default"))).
+dnl Does *not* test for __visibility__("protected") - which has tricky
+dnl semantics (see the 'vismain' test in glibc) and does not exist e.g. on
+dnl MacOS X.
+dnl Does *not* test for __visibility__("internal") - which has processor
+dnl dependent semantics.
+dnl Does *not* test for #pragma GCC visibility push(hidden) - which is
+dnl "really only recommended for legacy code".
+dnl Set the variable CFLAG_VISIBILITY.
+dnl Defines and sets the variable HAVE_VISIBILITY.
+
+AC_DEFUN([gl_VISIBILITY],
+[
+  AC_REQUIRE([AC_PROG_CC])
+  CFLAG_VISIBILITY=
+  HAVE_VISIBILITY=0
+  if test -n "$GCC"; then
+    AC_MSG_CHECKING([for simple visibility declarations])
+    AC_CACHE_VAL([gl_cv_cc_visibility], [
+      gl_save_CFLAGS="$CFLAGS"
+      CFLAGS="$CFLAGS -fvisibility=hidden"
+      AC_TRY_COMPILE(
+        [extern __attribute__((__visibility__("hidden"))) int hiddenvar;
+         extern __attribute__((__visibility__("default"))) int exportedvar;
+         extern __attribute__((__visibility__("hidden"))) int hiddenfunc (void);
+         extern __attribute__((__visibility__("default"))) int exportedfunc (void);],
+        [],
+        [gl_cv_cc_visibility=yes],
+        [gl_cv_cc_visibility=no])
+      CFLAGS="$gl_save_CFLAGS"])
+    AC_MSG_RESULT([$gl_cv_cc_visibility])
+    if test $gl_cv_cc_visibility = yes; then
+      CFLAG_VISIBILITY="-fvisibility=hidden"
+      HAVE_VISIBILITY=1
+    fi
+  fi
+  AC_SUBST([CFLAG_VISIBILITY])
+  AC_SUBST([HAVE_VISIBILITY])
+  AC_DEFINE_UNQUOTED([HAVE_VISIBILITY], [$HAVE_VISIBILITY],
+    [Define to 1 or 0, depending whether the compiler supports simple visibility declarations.])
+])

